<template>
  <v-app id="page-login">
    <v-main>
      <v-container fluid fill-height>
        <v-col v-if="$vuetify.breakpoint.smAndUp">
          <v-row justify="start" align="end" style="height: 90vh;">
            <!--            <v-img max-width="20vh" src="/img/ropaVejeroTransparente.png" />-->
            <!--            <v-img max-width="20vh" class="ml-10" src="/img/logo_UPPERDATA.svg" />-->
          </v-row>
        </v-col>
        <v-col>
          <v-row
            xs12
            sm8
            md4
            justify="end"
            align="center"
            style="height: 94vh;"
          >
            <v-card dark class="elevation-4" width="400px" height="100%" style="text-align: center; background: rgba(0, 0, 0, 0.7)">
              <v-toolbar dark color="accent">
                <v-toolbar-title>Ingresar al sistema</v-toolbar-title>
                <v-spacer />
                <v-icon v-if="isTesting">
                  fal fa-flask
                </v-icon>
              </v-toolbar>

              <v-card-text style="margin-top: 20%">
                <v-form v-if="!isTesting">
                  <v-text-field
                    ref="inputUser"
                    v-model="formLogin.user"
                    prepend-icon="fal fa-user"
                    name="login"
                    label="Usuario"
                    autofocus
                    color="accent"
                    placeholder="Ingresa tu usuario"
                    type="text"
                    :disabled="st.loading"
                    @keyup.native.enter="submitForm()"
                  />
                  <v-text-field
                    id="password"
                    v-model="formLogin.password"
                    prepend-icon="fal fa-key"
                    name="password"
                    label="Contraseña"
                    color="accent"
                    placeholder="Ingresa la contraseña"
                    type="password"
                    :disabled="st.loading"
                    @keyup.native.enter="submitForm()"
                  />
                  <div class="text-left error--text" style="height: 5px">
                    <span v-if="st.error401">El usuario o la contraseña son incorrectos.</span>
                  </div>
                </v-form>
                <div v-else>
                  <div class="title">
                    Auto login
                  </div>
                  <v-select
                    v-model="selectedUserTesting"
                    :items="testUsers"
                    item-text="label"
                    :item-value="p => p"
                    label="Usuario testing"
                  />
                </div>
              </v-card-text>
              <v-card-actions>
                <!--                                <h3><a class="regular" href="http://modernizacionsp.com/reclamos/public/password/reset">Olvidé mi contraseña.</a></h3>-->

                <v-spacer />
                <v-btn color="accent" block :loading="st.loading" @click="submitForm()">
                  Ingresar
                </v-btn>
              </v-card-actions>

              <v-row v-if="$vuetify.breakpoint.smAndDown" justify="center" align="center" class="pt-8">
                <v-col cols="5">
                  <!--                  <v-img width="40vh" src="/img/ropaVejeroTransparente.png" />-->
                </v-col>
              </v-row>
            </v-card>
          </v-row>
          <!--                    <v-flex style=" width: 12%;padding-top: 3%">-->
          <!--                        <img src="../static/img/logo_UPPERDATA.svg" style="padding-top: 5%;width: 100% " />-->
          <!--                    </v-flex>-->
        </v-col>
      </v-container>
    </v-main>
  </v-app>
</template>

<script lang="ts">
import { Component, Ref, Vue } from 'vue-property-decorator'
import { AuthStore } from '~/store/AuthStore'
import { Route } from '~/node_modules/vue-router'
import AppToast from '~/core/utils/AppToast'
import { App } from '~/core/App'

  @Component({
    layout: 'LoginLayout',
    head: { title: 'Login' }

  })
export default class login extends Vue {
    @Ref('refForm') htmlForm:any;

    isTesting:boolean = false;
    selectedUserTesting = null;
    get userLoged () {
      return AuthStore.logged
    }

    st = {
      loading: false,
      error401: false
    };

    formLogin = {
      user: '',
      password: ''
    };

    testUsers = [
      { label: 'admin', email: 'veljko@gmail.com', psw: '12345678' },
      { label: 'Vet', email: 'vet@testing.com', psw: '12345678' }
    ];

    mounted () {
      this.isTesting = App.isDev()
      this.selectedUserTesting = this.testUsers[0]
      if (this.userLoged) {
        this.$router.push('/')
      }
    }

    private redirectPage () {
      const route: Route = AuthStore.returnUrl
      if (route !== null) {
        const location: string = route.fullPath
        AuthStore.SET_RETURN_URL(null)
        this.$router.push(location)
        return
      }
      this.$router.push('/')
    }

    submitForm () {
      let user = ''
      let password = ''
      if (!this.isTesting) {
        const formValid = this.formLogin.user.length > 1 && this.formLogin.password.length > 1
        if (!formValid) {
          AppToast.error('Completa el formulario')
          return
        }

        user = this.formLogin.user
        password = this.formLogin.password
      } else {
        user = this.selectedUserTesting.email
        password = this.selectedUserTesting.psw
      }

      this.st.loading = true
      this.st.error401 = false
      AuthStore.login({ user, password }).then(() => {
        this.redirectPage()
      }).catch(() => {
        this.st.error401 = true
      }).finally(() => { this.st.loading = false })
    }
}
</script>

<style lang="scss">
    #page-login{
        //background-image: url("../static/img/fondo.jpeg");
      background-image: url("https://source.unsplash.com/1600x900/?animals,pets");
      background-size: 100%;
      background-repeat: no-repeat;
      background-position: center;

    }
    a:link
    {
        text-decoration:none;
    }
</style>
